package bou.amine.apps.readerforselfossv2.android.viewmodel

import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import bou.amine.apps.readerforselfossv2.repository.Repository
import kotlinx.coroutines.flow.MutableSharedFlow
import kotlinx.coroutines.flow.asSharedFlow
import kotlinx.coroutines.launch

class AppViewModel(private val repository: Repository) : ViewModel() {
    private val _toastMessageProvider = MutableSharedFlow<String>()
    val toastMessageProvider = _toastMessageProvider.asSharedFlow()

    init {
        viewModelScope.launch {
            repository.isConnectionAvailable.collect { isConnected ->
                if (isConnected && repository.connectionMonitored) {
                    _toastMessageProvider.emit("Network connection is now available")
                } else if (repository.connectionMonitored){
                    _toastMessageProvider.emit("Network connection lost")
                }
            }
        }
    }
}